﻿using System;
using System.ComponentModel;
using System.Configuration;
using System.IO;

using Zeta.Common.Xml;
using Zeta.Game;
using Zeta.XmlEngine;

namespace TaegukSpammer
{
    [XmlElement("TaegukSpammerSettings")]
    class TaegukSpammerSettings : XmlSettings
    {
        public TaegukSpammerSettings() : base(Path.Combine(SettingsDirectory, BattleTagName, "TaegukSpammer_"+PlayerClass+".xml")) { }

        private static TaegukSpammerSettings _instance;
        public static TaegukSpammerSettings Instance
        {
            get { return _instance ?? (_instance = new TaegukSpammerSettings()); }
        }

        private static string _battleTagName;
        private static string BattleTagName
        {
            get
            {
                if (string.IsNullOrWhiteSpace(_battleTagName) && ZetaDia.Service.Hero.IsValid)
                    _battleTagName = ZetaDia.Service.Hero.BattleTagName;
                return _battleTagName;
            }
        }
		
		private static string _playerClass;
        private static string PlayerClass
        {
            get
            {
                if (string.IsNullOrWhiteSpace(_playerClass) && ZetaDia.Service.Hero.IsValid)
                    _playerClass = ZetaDia.Service.Hero.Class.ToString();
                return _playerClass;
            }
        }

        [XmlElement("Skill")]
        [DefaultValue(-1)]
        [Setting]
        public int Skill
        {
            get
            {
                return _skill;
            }
            set
            {
                _skill = value;
                OnPropertyChanged("Skill");
            }
        }
        private int _skill;
		
		[XmlElement("Interval")]
        [DefaultValue(2300)]
        [Setting]
        public int Interval
        {
            get
            {
                return _interval;
            }
            set
            {
                _interval = (int)value;
                OnPropertyChanged("Interval");
            }
        }
        private int _interval;
		
		[XmlElement("OOCDelay")]
        [DefaultValue(9000)]
        [Setting]
        public int OOCDelay
        {
            get
            {
                return _oocdelay;
            }
            set
            {
                _oocdelay = (int)value;
                OnPropertyChanged("OOCDelay");
            }
        }
        private int _oocdelay;
    }
}
